//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Buy"
#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x0000FF
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern int Period1 = 14;
extern int Period2 = 14;


double myPoint; //initialized in OnInit

void myAlert(string type, string message)
{
   if(type == "print") Print(message);
   else if(type == "error")
   {
      Print(type+" | mfi cross @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
   }
   else if(type == "order")  { }
   else if(type == "modify") { }
}

int OnInit()
{   
   SetIndexBuffer(0,Buffer1); SetIndexEmptyValue(0,EMPTY_VALUE); SetIndexArrow(0,241);
   SetIndexBuffer(1,Buffer2); SetIndexEmptyValue(1,EMPTY_VALUE); SetIndexArrow(1,242);
   //initialize myPoint
   myPoint = Point();
   if(Digits()==5 || Digits()==3)
   {
      myPoint *= 10;
   }
   return(INIT_SUCCEEDED);
}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
   {
      ArrayInitialize(Buffer1, EMPTY_VALUE);
      ArrayInitialize(Buffer2, EMPTY_VALUE);
   }
   else limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
   {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      
      //Indicator Buffer 1
      if(iMFI(NULL, PERIOD_CURRENT, Period1, i) > iStochastic(NULL, PERIOD_CURRENT,Period2,1,1,MODE_SMA,0,MODE_MAIN,i)
      && iMFI(NULL, PERIOD_CURRENT, Period1, i+1) < iStochastic(NULL,PERIOD_CURRENT,Period2,1,1,MODE_SMA,0,MODE_MAIN,i+1) //Money Flow Index crosses above William's Percent Range
      )
      {
         Buffer2[i] = High[i]+30*_Point; //Set indicator value at Candlestick Low
      }
      else { Buffer2[i] = EMPTY_VALUE;}
      
      //Indicator Buffer 2
      if(iMFI(NULL, PERIOD_CURRENT, Period1, i) < iStochastic(NULL, PERIOD_CURRENT,Period2,1,1,MODE_SMA,0,MODE_MAIN,i)
      && iMFI(NULL, PERIOD_CURRENT, Period1, i+1) > iStochastic(NULL,PERIOD_CURRENT,Period2,1,1,MODE_SMA,0,MODE_MAIN,i+1) //Money Flow Index crosses below William's Percent Range
      )
      {
         Buffer1[i] = Low[i]-30*_Point; //Set indicator value at Candlestick High
      }
      else { Buffer1[i] = EMPTY_VALUE; }
   }
   return(rates_total);
}
